/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
package net.smartlab.web.test;

import java.io.File;
import java.net.URL;

import junit.framework.TestCase;
import net.smartlab.web.Domain;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * TODO documentation
 * 
 * @author rlogiacco
 */
public abstract class BasicDomainTestCase extends TestCase {

	/**
	 * Provides logging for the test cases.
	 */
	protected Log logger = LogFactory.getLog(this.getClass());


	/**
	 * Default constructor.
	 */
	public BasicDomainTestCase() {
		super();
	}

	/**
	 * Named constructor.
	 * 
	 * @param name test name.
	 */
	public BasicDomainTestCase(String name) {
		super(name);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		if (logger.isDebugEnabled()) {
			logger.debug("setUp() - start");
		}
		DomainTestSupport support = new DomainTestSupport(this.getDomainConfiguration());
		Domain.setConfigurationStrategy(support);
		super.setUp();
	}

	/**
	 * Returns the configuration to be used for test purposes. The default
	 * implementation uses the file <code>res/smartweb.jar.xml</code> but the
	 * method could be overriden to support different configuration files for
	 * different tests.
	 * 
	 * @return the configuration to be used for test purposes.
	 * @throws Exception if the resouce fails to open.
	 */
	protected URL getDomainConfiguration() throws Exception {
		return new File("res/smartweb.jar.xml").toURI().toURL();
	}

	/**
	 * @deprecated renamed to getDomainConfiguration
	 * @see getDomainConfiguration()
	 */
	protected URL getDomainConfigurationFile() throws Exception {
		return this.getDomainConfiguration();
	}
}
