/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
package net.smartlab.web.test;

import net.smartlab.web.Enumeration;
import junit.framework.Assert;

/**
 * TODO documentation
 * 
 * @author gcontartese
 * @author rlogiacco
 */
public class EnumerationAssert extends Assert {

	/**
	 * @TODO documentation
	 */
	private EnumerationAssert() {

	}

	/**
	 * Asserts that after a decode Enumeration are equals. If it isn't it throws
	 * an AssertionFailedError with the given message.
	 * 
	 * @TODO documentation
	 * @param expected
	 * @param actual
	 */
	public static void assertDecode(Enumeration expected, int actual) {
		Enumeration decoded = expected.decode(actual);
		assertEquals(expected, decoded, "Decode of `" + actual + "`");

	}

	/**
	 * @TODO documentation
	 * @param expected
	 * @param actual
	 * @param message
	 */
	public static void assertEquals(Enumeration expected, Enumeration actual, String message) {
		StringBuffer sb = new StringBuffer();
		if (message != null) {
			sb.append(message);
		}
		if (!actual.equals(expected)) {
			sb.append(" Expected : <" + expected.getDisplay() + ">, actual <" + actual.getDisplay() + ">. ");
			throw new AssertionError(sb.toString());
		}
	}
}
